package pacworld;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/** A package delivery GUI class. */
public class PacGUI extends JFrame {
  private JButton resetButton;
  private JButton runButton;
  private JButton stepButton;
  private JButton completeButton;
  private JPanel buttonPanel;
  private CustomPanel mapPanel;
  private boolean step = false;
  private boolean run = false;
  private boolean dontUpdate = false;
  private boolean reset = false;
  private int i = 0;
  private PackageWorld world = null;

  public PacGUI(PackageWorld world) {
    super("Package Delivery Environment");
    this.world = world;
    mapPanel = new CustomPanel();
    reset = false;

    runButton = new JButton("Run");
    runButton.addActionListener(
      new ActionListener() {
        public void actionPerformed(ActionEvent event)
        {
          dontUpdate = false;
          run = true;
        }
      }
    );

    /*
    resetButton = new JButton("Reset");
    resetButton.addActionListener(
      new ActionListener() {
        public void actionPerformed(ActionEvent event)
        {
          reset = true;
          run = true;
          PackageWorld.setReset(true);
        }
      }
    );
    */

    stepButton = new JButton("Step");
    stepButton.addActionListener(
      new ActionListener() {
        public void actionPerformed(ActionEvent event)
        {
          dontUpdate = false;
          step = true;
          run = false;
        }
      }
    );

    completeButton = new JButton("Complete");
    completeButton.addActionListener(
      new ActionListener() {
        public void actionPerformed(ActionEvent event)
        {
          run = true;
          dontUpdate = true;
        }
      }
    );

    buttonPanel = new JPanel();
    buttonPanel.setLayout(new GridLayout(1, 4));
    buttonPanel.add(runButton);
    buttonPanel.add(stepButton);
    buttonPanel.add(completeButton);
    // buttonPanel.add(resetButton);
    Container container = getContentPane();
    container.add(mapPanel, BorderLayout.CENTER);
    container.add(buttonPanel, BorderLayout.SOUTH);
    setSize(5 * world.getWorldSize() + 10, 5 * world.getWorldSize() + 60);
    setVisible(true);
  }

  public void drawMap(PackageState state) {
      /*
    if (reset)
      throw new Exception("reset simulator");
      */
    if (dontUpdate)
      return;
    if (i == 0)
      mapPanel.drawMap(state); 
    i++;
    if (i >= world.getNumAgents())
      i = 0;
    while(!step && !run) {
    }
    if (!run && i == 0)
      step = false;
    else if (run && i == 0) {
      try {
        Thread.sleep(100);
      }
      catch (InterruptedException ie) {
      }
    }
  }
}
