package pacworld;

/** The representation of an agent in an agent's percept. This includes
    the agente's id and current location. */
public class VisibleAgent {
 
  private int id = 0;
  private int x = 0;
  private int y = 0;

  public VisibleAgent(int id, int x, int y) {
    this.id = id;
    this.x = x;
    this.y = y;
  }

  /** Get the unique integer id for the agent. */
  public int getId() {
    return id;
  }

  /** Get the X location of the agent. */
  public int getX() {
    return x;
  }

  /** Get the Y location of the agent. */
  public int getY() {
    return y;
  }

  public boolean equals(Object obj) {
      
    VisibleAgent otherAgent;

    if (obj instanceof VisibleAgent) {
      otherAgent = (VisibleAgent)obj;
      if (id == otherAgent.getId())
	return true;
    }
    return false;
  }

  public String toString() {
    return "Agent " + id + ": Loc=(" + x + ", " + y + ")";
  }
}
